<?php

/**
 * phpcms小程序插件 自动推送接口
 * 请把该文件转移到/phpcms/modules/content/classes下
 * -----------------------------
 * 支持QQ:2863868475
 * 官网：https://www.tengcee.com
 * 版权：郑州腾石科技（FUCK六久阁无耻抄袭）
 * 日期：2019-11-22
 * -----------------------------
 */
defined('IN_PHPCMS') or exit('No permission resources.');
class Push{
    private $aid;
    function __construct($siteid){
        $this->db = pc_base::load_model('content_model');
        $this->siteid = $siteid;
        $this->categorys = getcache('category_content_'.$siteid,'commons');
        $this->type = 1;//推送级别（默认1天级）
        $this->category_id = 1;//推送类目,参考：https://developers.weixin.qq.com/miniprogram/introduction/widget/we-search/WXAPAGES.html
        $this->page = array(
            'show' => "/pages/show/show",//默认内容页小程序路径
            'list' => "/pages/list/list",//默认栏目目页小程序路径
        );
        //自定义页面类型（只需要写特殊页面即可）
        $this->diypage = array(
            // array(
            //     'catid' => '11',
            //     'show'   => "/pages/service/show",
            //     'list'   => "/pages/service/service",
            // ),
            // array(
            //     'catid' => '6,8',
            //     'show'   => "/pages/show2/show2",
            //     'list'   => "/pages/list2/list2",
            // ),
        );
        $this->fuck = 'fuck lol9';
        $this->copy = "Tengshi";
    }
    /**
     * 百度推送
     * $id文章id
     * $type 推送级别
     */
    function bdpush($id,$catid,$aid,$type=1){
        $this->aid = $aid;
        $this->type = $type;
        $appinfo = $this->getAppinfo($aid);
        $appKey = $appinfo['appid'];
        $appSecret = $appinfo['appsecret'];
        $access_token = $this->getAccessToken($appKey,$appSecret,'baidu');
        $dat = array();
        $dat['type'] = $this->type;
        $url_list = array();

        $modelid = $this->categorys[$catid]['modelid'];
        $this->db->set_model($modelid);
        $sql = "status=99 AND id IN ($id)";
        $order = "listorder desc, id desc";
        $data = $this->db->select($sql, '*', '', $order, '', 'id');
        foreach($data as $v){
            $page       = $this->getPageUrl($catid);
            $url_list[] = $page['show']."?id=".$v['id']."&catid=".$catid;
        };
        $dat['url_list'] = implode(",",$url_list);
        $api = 'https://openapi.baidu.com/rest/2.0/smartapp/access/submitsitemap/api?access_token='.$access_token;
        $res = json_decode($this->curl($api,$dat), true);
        $re = array();
        if($res['msg'] == "success"){
            $re['status'] = "success";
            $re['code'] = 1;
            return $re;//成功
        }else{
            $re['status'] = "fail".$res['msg'];
            $re['code'] = 0;
            return $re;//失败
        }
    }
    /**
     * 微信推送
     */
    function wxpush($id,$catid,$aid,$category_id=1){
        $this->aid = $aid;
        $this->category_id = $category_id;
        $appinfo = $this->getAppinfo($aid);
        $appKey = trim($appinfo['appid']);
        $appSecret = trim($appinfo['appsecret']);
        $appKey  = 'wx415f23bfd9eb8973';
        $appSecret = '3d2af04987b0b323e27df7e478f69c21';
        $access_token = $this->getAccessToken($appKey,$appSecret,'weixin');
        $dat = array();
        $pages = array();
        $ids = explode(",",$id);
        foreach($ids as $a){
            $temparray = array();
            $id = $a;//文章id
            $info = $this->get_content($catid,$id);//文章
            $page     = $this->getPageUrl($catid);
            $temparray['path']  = ltrim($page['show'],'/');
            $temparray['query'] = 'id=' . $id . "&catid=".$catid;
            $temparray['data-list'] = array(
                "@type"=> "wxsearch_cpdata",
                "update" => 1,//新增，3：删除
                "content_id" => $id,
                "category_id"=> $this->category_id,
                "page_type"=> 2,
                "h5_url"=> "",
                "weapp_url"=> $temparray['path']."?id=".$id."&catid=".$catid,
                "title" => $info['title'],
                "abstract" => $info['description'],
                "cover_img" => array(
                    "cover_img_url" => $info['thumb'],
                    "cover_img_size" => 1
                ),
                "mainbody" => $info['description'],
                "time_publish" =>  $info['inputtime'],
                "time_modify" =>  $info['updatetime'],
                "tag" => array_filter(explode(" ",$info['keywords']))
                //"pv" =>  $info['click']
            );
            $pages[] =  $temparray;
        }
        $dat['pages'] = $pages;
        $dat = json_encode($dat,JSON_UNESCAPED_SLASHES);
        $api = 'https://api.weixin.qq.com/wxa/search/wxaapi_submitpages?access_token='.$access_token;
        $res = json_decode($this->curl($api,$dat), true);
        $re = array();
        if($res['errmsg'] == "ok"){
            $re['status'] = "success";
            $re['code'] = 1;
            return $re;//成功
        }else{
            $re['status'] = "fail,错误类型：".$res['errcode'];
            $re['code'] = 0;
            return $re;//失败
        }
    }
    /**
     * tag的推送
     */
    function tagpush($tag,$aid,$type = 1){
        $this->aid = $aid;
        $this->type = $type;
        $appinfo = $this->getAppinfo($this->aid);
        $appKey = $appinfo['appid'];
        $appSecret = $appinfo['appsecret'];
        $access_token = $this->getAccessToken($appKey,$appSecret,'baidu');
        $dat = array();
        $dat['type'] = $this->type;
        if(empty($tags)) return;
        if (strpos($tag, ',')!== false) {
            $tags = explode(',', $tag);
        } else {
            $tags[0] = $tag;
        }
        $url_list = array();
        $tagurl = '/pages/tag/tag';
        foreach($tags as $i){
            $url_list[] =$tagurl.'?tag='.$i;
        }
        $dat['url_list'] = implode(",",$url_list);
        $api = 'https://openapi.baidu.com/rest/2.0/smartapp/access/submitsitemap/api?access_token='.$access_token;
        $res = json_decode($this->curl($api,$dat), true);
        $re = array();
        if($res['msg'] == "success"){
            $re['status'] = "success";
            $re['code'] = 1;
            return $re;//成功
        }else{
            $re['status'] = "fail".$res['msg'];
            $re['code'] = 0;
            return $re;//失败
        }
    }
    function curl($url,$data = ''){
        $ch = curl_init();
        $params[CURLOPT_URL] = $url;    //请求url地址
        $params[CURLOPT_HEADER] = false; //是否返回响应头信息
        $params[CURLOPT_RETURNTRANSFER] = true; //是否将结果返回
        //$params[CURLOPT_FOLLOWLOCATION] = true; //是否重定向
        //$params[CURLOPT_TIMEOUT] = 50; //超时时间
        if(!empty($data)){
            $params[CURLOPT_POST] = true;
            $data =  is_array($data) ? http_build_query($data) : $data;
            $params[CURLOPT_POSTFIELDS] = $data;
            $params[CURLOPT_NOBODY] = false;
            $params[CURLOPT_HTTPHEADER] = array("Content-Type: application/x-www-form-urlencoded");
        }
        $params[CURLOPT_SSL_VERIFYPEER] = false;//请求https时设置,还有其他解决方案
        $params[CURLOPT_SSL_VERIFYHOST] = false;//请求https时,其他方案查看其他博文
        curl_setopt_array($ch, $params); //传入curl参数
        $content = curl_exec($ch); //执行
        curl_close($ch); //关闭连接
        return $content;
    }
    /**
     * 组装url
     */
    function getPageUrl($catid){
        if(empty($catid)){
            return $this->page;
        }
        $isdiy  = 0;
        foreach($this->diypage as $k =>$diy){
            $idarray = explode(",",$diy['catid']);
            if(in_array($catid,$idarray)){
                $diypage = $diy;
                $isdiy = 1;
                break;
            }
            $pids = $this->categorys[$catid]['arrparentid'];//所有父栏目
            $pids = explode(",", $pids);
            if(is_array($pids)){
                foreach ($pids as $key => $v) {
                    if(in_array($v,$idarray)){
                        $diypage = $diy;
                        $isdiy = 1;
                        break;
                    }
                }
            }   
        }
        return $isdiy ? $diypage : $this->page;
    }
    /*
     * 获取access
     */
    function getAccessToken($appKey,$appSecret,$type='baidu'){
        if($type == 'baidu'){
            $api = "https://openapi.baidu.com/oauth/2.0/token?grant_type=client_credentials&client_id=" . $appKey . "&client_secret=" . $appSecret . "&scope=smartapp_snsapi_base";
        }else if($type == 'weixin'){
            $api = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" . $appKey . "&secret=" . $appSecret;
        }
        $res = json_decode($this->curl($api), true);
        $access_token = $res['access_token'];
        return $access_token;
    }

    function getAppinfo($aid){
        $xiao_db = pc_base::load_model('xiaochengxu_model');
        $app = $xiao_db->get_one(array('aid' => $aid, 'status' => "1"));
        if($app){
            return $app;
        }else{
            $res['errMsg'] = "您的小程序不存在或者已关闭";
            $res['status'] = "101";
            echo json_encode($res);
            die;
        }
    }
    /**
     * 获取全部栏目 
     */
    function get_allcat(){
        global $dsql;
        $query = "Select * From `#@__arctype`";
        $dsql->SetQuery($query);
        $dsql->Execute();
        $res = array();
        $i   = 0;
        while($cat = $dsql->GetArray()){
            $res[$i] = $cat;
            $i++;
        }
        return $res;
    }

    /**
     * 获取单篇信息
     * 
     * @param $catid
     * @param $id
     */
    public function get_content($catid,$id) {
        $catid = intval($catid);
        $id = intval($id);
        if(!$catid || !$id) return false;
        if(isset($this->categorys[$catid]) && $this->categorys[$catid]['type'] == 0) {
            $modelid = $this->categorys[$catid]['modelid'];
            $this->db->set_model($modelid);
            $r = $this->db->get_one(array('id'=>$id));
            //附属表
            $this->db->table_name = $this->db->table_name.'_data';
            $r2 = $this->db->get_one(array('id'=>$id));
            if($r2) {
                return array_merge($r,$r2);
            } else {
                return $r;
            }
        }
        return true;
    }
}
?>